.nolist
include \masm32\include\masm32rt.inc
; include \masm32\Gfa2Masm\Gfa2Masm.inc	; needed only for deb macro
.686
.xmm

include \masm32\macros\timers.asm		; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

  LOOP_COUNT	= 10000		; 10000 is enough
  ByteCount	= 2048		; don't go higher than 100000, ml.exe would slow down
  MakeSlow 	= 1		; change to 1 to see a really slow MemCoC3
  UsePP =	1		; use push/pop to save ecx (a few cycles faster, a few bytes shorter)	

cyctProcs	equ crt_strcpy, MemCo1, MemCo2, MemCoC3, MemCoP4, MemCoC2, MemCoL	;, crt_strcpy
MemCo0_Desc	equ rep movsd/src-al	; src-aligned
MemCo1_Desc	equ rep movsd/dest-al	; dest-aligned
MemCo2_Desc	equ movdqa/psllq
MemCoC3_Desc	equ lps+hps/src+dest
MemCoP4_Desc	equ movdqa/dest-al
MemCoC2_Desc	equ movdqa/src-al
MemCo6_Desc	equ lps+hps/src+dest
MemCoL_Desc	equ Masm32/library
_imp__strcpy_Desc equ CRT/strcpy

cyctSleepMs = 	5

UseRepMov =	0	; slow...
ShowAll =	0	; show some more algos
cyctShowSize = 	0
; cyctShowDiff =	0
; cyctCutFast =	10
; cyctShowSlow =	0	; show the slowest n readings (<0: show only fast readings)

MemCo0	PROTO: DWORD, :DWORD, :DWORD	; dest, src, ct
MemCo1	PROTO: DWORD, :DWORD, :DWORD	; dest, src, ct
MemCo2	PROTO: DWORD, :DWORD, :DWORD	; dest, src, ct
MemCoC3	PROTO: DWORD, :DWORD, :DWORD	; dest, src, ct
MemCoP4	PROTO: DWORD, :DWORD, :DWORD	; dest, src, ct
MemCoC2	PROTO: DWORD, :DWORD, :DWORD	; dest, src, ct
MemCo6	PROTO: DWORD, :DWORD, :DWORD	; dest, src, ct
MemCoL	PROTO: PTR BYTE, :PTR BYTE, :DWORD	; dest, src, ct

Externdef MemCo0_END:NEAR
Externdef MemCo1_END:NEAR
Externdef MemCo2_END:NEAR
Externdef MemCoC3_END:NEAR
Externdef MemCoP4_END:NEAR
Externdef MemCoC2_END:NEAR
Externdef MemCo6_END:NEAR
Externdef MemCoL_END:NEAR

ShowCpu	PROTO:DWORD

lineifat MACRO cond, action
if cond
	action
endif
ENDM

cyctTable MACRO desc, args:VARARG
  LOCAL tmp$, is, c1, tl$, tr$
  cyctColW1 = 12
  cyctColW = -9
  ifndef cyctTxAlgo
  	.data
	cyctTxAlgo	db 13, 10, "Algo", 0
	.code
  endif
  ifndef cyctTxDesc
  	.data
	cyctTxDesc	db 13, 10, "Description", 0
	cyctTxDes2	db 13, 10, 0
	cyctTxSize	db 13, 10, "Code size", 0
	cyctTxQuestMark	db "?", 0
	cyctTxLine db 13, 10, "-------------------------------------------------------------------------------------------------------------------------------------------------------------", 0
	.code
  endif
  .if cyctTableMode==0
  	cyctDesc1 equ <@>
  	cyctDesc2 equ <@>
  	cyctDesc1Ct = 0
  	cyctDesc2Ct = 0
  	cyctSizeCt = 0
  	cyctLineCt = cyctColW1
	printFix cyctColW1, offset cyctTxAlgo		; 13, 10, "Algo"
	% FOR algo, <cyctProcs>
	  	cyctLineCt = cyctLineCt - cyctColW
		printFix cyctColW, chr$("&algo&")
		; if (OPATTR &algo&_Desc) and 127
		if 1 ;def &algo&_Desc
		  	cyctDesc1Ct = cyctDesc1Ct + 1
			is INSTR &algo&_Desc, </>
			if is
				tmp$ SUBSTR &algo&_Desc, 1, is-1
				tmp2$ SUBSTR &algo&_Desc, is+1
			  	cyctDesc2Ct = cyctDesc2Ct + 1
				cyctDesc1 CATSTR cyctDesc1, <, >, tmp$
			else
				cyctDesc1 CATSTR cyctDesc1, <, >, &algo&_Desc
				tmp2$ equ < >
			endif
			cyctDesc2 CATSTR cyctDesc2, <, >, tmp2$
		endif
		if (OPATTR &algo&_END) and 127
			cyctSizeCt = 1
		endif
	ENDM
	if cyctDesc1Ct
		printFix cyctColW1, offset cyctTxDesc		; 13, 10, "Desc"
		% FOR desc1, <cyctDesc1>
		ifdif <desc1>, <@>
			ifb <desc1>
				printFix cyctColW, chr$(32)
			else
				printFix cyctColW, chr$("&desc1&")
			endif
		endif
		ENDM
	endif
	if cyctDesc2Ct
		printFix cyctColW1, offset cyctTxDes2		; 13, 10
		% FOR desc1, <cyctDesc2>
		ifdif <desc1>, <@>
			ifb <desc1>
				printFix cyctColW, chr$(32)
			else
				printFix cyctColW, chr$("&desc1&")
			endif
		endif
		ENDM
	endif
	if cyctSizeCt
		printFix cyctColW1, offset cyctTxSize		; 13, 10
		% FOR algo, <cyctProcs>
			if (OPATTR &algo&_END) and 127
				mov eax, offset &algo&_END-&algo&
				printFix cyctColW, str$(eax)
			else
				printFix cyctColW, offset cyctTxQuestMark	; ?
			endif
		ENDM
	endif
	printFix cyctLineCt, offset cyctTxLine
  .endif
  is INSTR 1, <desc>, <#bc>
  if is
	tl$ SUBSTR <desc>, 1, is-1
	tr$ SUBSTR <desc>, is+3
;	% echo tl$+tr$
	tmp$ CATSTR <printFix cyctColW1, chr$(13, 10, >, tl$, %ByteCount, tr$, <)>
;	% echo tmp$
	tmp$
  else
	printFix cyctColW1, chr$(13, 10, &desc&)
  endif
  and cyctTableMode, 0
  % FOR algo, <cyctProcs>
	inc cyctTableMode
 	cyct_begin
		invoke algo, args
	cyct_end <arg>		; unrolled once - problem is 32 byte chunks only
  ENDM
  or cyctTableMode, -1	; set flag: -1=do not repeat table head
;  and cyctTableMode, 0	; set flag: 0=repeat table head
ENDM	; cyctTable

cyct_begin MACRO cyct_lc, cyct_prio	;; both arguments are optional
LOCAL cyct_prioclass, lbl
  ifndef cyctCutFast
	cyctCutFast = 10
  endif
  ifndef cyctShowSlow
	cyctShowSlow = 0
  endif
  ifnb <cyct_lc>
	cyctSubCt = cyct_lc/1000 				;; 1000 entries in cyctSortTable
  else
	cyctSubCt = LOOP_COUNT/1000
  endif
  if cyctSubCt lt 50
  	cyctSubCt = 50
  	; 25 seems to be the minimum for reasonable timings
  endif
  ifnb <cyct_prio>
	cyct_prioclass equ <cyct_prio> 		;; v v default below
  else
	cyct_prioclass equ HIGH_PRIORITY_CLASS
  endif
  ifndef cyctShowDiff
	cyctShowDiff = 0
  endif
  ifndef cyctShowSize
	cyctShowSize = 1
  endif
  ifdef cyctSleepMs
	invoke Sleep, cyctSleepMs
  endif
  ; int 3
  and cyctCounter, 0								;; clear the counter
  mov cyctSize, offset lbl
  .Repeat
	counter_begin cyctSubCt, cyct_prioclass
lbl:	
	
ENDM
; -------------------------------------------------------------------------	mov eax, len(offset Tst50)	; the code in between the two macros ---------------------
cyct_end MACRO arg
LOCAL tmp$, lbl
lbl:
  counter_end
  	mov edx, cyctCounter
  	mov [cyctSortTable+4*edx], eax
	inc cyctCounter
  .Until edx>=sizeof cyctSortTable/4-1
  sub cyctSize, offset lbl
  neg cyctSize
  tmp$ CATSTR <mov eax, chr$(">, <arg>, <")>
  ;% echo tmp$
  tmp$
  call cyct_endP	;; calculate and show results
ENDM

csize macro algo
LOCAL  tmp$
  tmp$ CATSTR <algo>, <            >	;; 12 blanks
  tmp$ SUBSTR tmp$, 1, 12
  tmp$ CATSTR <print ">, tmp$, < = ">
  tmp$
  mov eax, offset &algo&_END-&algo&
  print str$(eax), 13, 10
ENDM

ifline MACRO condition, act1, act2, act3, act4, act5
.if condition
	act1
	act2
	act3
	act4
	act5
.endif
ENDM

printFix MACRO strlen, arg
LOCAL is, tmp$
  ifndef cyctFixPbuf
	.data?
	cyctFixPbuf	dd 80 dup(?)
	.code
  endif
  is INSTR <arg>, <">
  if is eq 1
  	.data
	tmpstr db &arg&, 0
  	.code
	mov eax, offset tmpstr
  else 
	is INSTR <arg>, <ADDR>		; str$ returns "ADDR ???"
	if is eq 0
		is INSTR <arg>, <addr>
	endif
	if is eq 1
		tmp$ SUBSTR <arg>, 5
		tmp$ CATSTR <mov eax, offset >, tmp$
		tmp$
	else
		mov eax, arg
	endif
  endif
  push strlen
  pop ecx
  call printFixP
ENDM

ShowAlignment MACRO srcarg, destarg
LOCAL tmp$
  mov edi, offset srcarg
  mov eax, edi
  and eax, -16
  sub edi, eax
  print chr$(13, 10, "**", 9, "Alignment: Source = ")
  print str$(edi), ", Destination = "
  mov edi, offset destarg
  mov eax, edi
  and eax, -16
  sub edi, eax
  print str$(edi), ", ct="
  print str$(ByteCount), " **"
ENDM

.data?
debflag	dd ?
cyctSize	dd ?
cyctStrLen	dd ?
cyctCounter	dd ?, ?, ?, ?, ?
cyctSortTable	dd 1000 dup(?)	; overwrites next dd
cyctTableMode	SDWORD ?

align 16
src16	db ?	; src16 is para-aligned
src1	db 6 dup(?)
src7	db ?
src8	db ?
src9	db 6 dup(?)
src15	dd ByteCount/4+9 dup(?)

align 16
dest16	db ?
dest1	db 6 dup(?)
dest7	db ?
dest8	db ?
dest9	db 6 dup(?)
dest15	dd ByteCount/4+9 dup(?)

padding	dd 100 dup (?)	; one algo writes beyond...!

.code
MyString	db "A 16 bytes text.", 0

start:
	invoke ShowCpu, 1	; prints the brand string and returns SSE level in eax
	mov ebx, ByteCount/16
	mov esi, offset src16
	.Repeat
		invoke lstrcat, esi, offset MyString
		dec ebx
	.Until Zero?
	mov cyctStrLen, len(esi)
	mov dword ptr [esi+eax-4], "++++"		; show the end of the text as ++++

	; call ChkMe		; 5 minutes at 100% CPU

	REPEAT MakeSlow
		print chr$(13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13)
	ENDM

	; ####### TABLE #############################
	or DestShowVar, -1	; flag: Do not yet use DestShow
;	tmp$ CATSTR <">, %ByteCount, <, d8s8">		; fails with tmp$, if not local in [url=+0]printFix[/url]
;	cyctTable tmp$, offset dest8, offset src8, ByteCount
;	or debflag, -1
	REPEAT 1									; #bc is substituted by %ByteCount
	mov edx, offset src16
	mov byte ptr [edx+ByteCount], 0
	cyctTable "#bc, d0s0-0", offset dest16, offset src16, ByteCount
	cyctTable "#bc, d1s1-0", offset dest1, offset src1, ByteCount
	cyctTable "#bc, d7s7-0", offset dest7, offset src7, ByteCount
	and DestShowVar, 0		; use DestShow now in the proc where ChkResult is activated
	cyctTable "#bc, d7s8-1", offset dest7, offset src8, ByteCount
	cyctTable "#bc, d7s9-2", offset dest7, offset src9, ByteCount
	cyctTable "#bc, d8s7+1", offset dest8, offset src7, ByteCount
	cyctTable "#bc, d8s8-0", offset dest8, offset src8, ByteCount
	cyctTable "#bc, d8s9-1", offset dest8, offset src9, ByteCount
	and DestShowVar, 0		; use DestShow now in the proc where ChkResult is activated
	cyctTable "#bc, d9s7+2", offset dest9, offset src7, ByteCount
	cyctTable "#bc, d9s8+1", offset dest9, offset src8, ByteCount
	cyctTable "#bc, d9s9-0", offset dest9, offset src9, ByteCount
;	and DestShowVar, 0		; use DestShow now in the proc where ChkResult is activated
	cyctTable "#bc, d15s15-0", offset dest15, offset src15, ByteCount
	ByteCount = ByteCount/2
	print chr$(13,10)
	ENDM

	if 0
	print "MC: "
	mov edi, offset dest16
	mov ecx, ByteCount
	and DestShowVar, 0		; use DestShow now
	call DestClear		; to test correctness of result
	invoke MemCoL, offset src16, offset dest16, 2048
	call DestShow		; to test correctness of result
	endif
;	cyctTable "16, d8s8", offset dest8, offset src8, 16
;	cyctTable "16, d7s7", offset dest7, offset src7, 16
;	cyctTable "16, d7s9", offset dest7, offset src9, 16
;	cyctTable "16, d9s7", offset dest9, offset src7, 16
;	cyctTable "16, d9s9", offset dest9, offset src9, 16
	and cyctTableMode, 0		; set flag: 0=repeat table head

	; old stuff below, ignore
	if 0
	cyct_begin
		invoke crt_strcpy, offset dest8, offset src8	; no ByteCount
	cyct_end <crt_strcpy     >
	cyct_begin
		invoke MemCoL, offset src8, offset dest8, ByteCount
	cyct_end <MemCoL        >
	endif
	REPEAT 0
	cyct_begin
		mov esi, offset src
		mov edi, offset dest
		mov ecx, ByteCount/16/2
		.Repeat
			movdqu xmm0, [esi]				; read src
			lea esi, [esi+32]
			movlps qword ptr [edi], xmm0		; write dest
			movhps qword ptr [edi+8], xmm0
			movdqu xmm0, [esi-16]				; read src
			movlps qword ptr [edi+16], xmm0	; write dest
			movhps qword ptr [edi+8+16], xmm0
			dec ecx
			lea edi, [edi+32]
		.Until Zero?
	cyct_end <movdqu+movlps B>
	ENDM
	REPEAT 0
	cyct_begin
		mov esi, offset src
		mov edi, offset dest
		mov ecx, ByteCount/16/2
		.Repeat
			lddqu xmm0, oword ptr [esi]				; read src
			lea esi, [esi+32]
			movlps qword ptr [edi], xmm0		; write dest
			movhps qword ptr [edi+8], xmm0
			lddqu xmm0, oword ptr [esi-16]				; read src
			movlps qword ptr [edi+16], xmm0	; write dest
			movhps qword ptr [edi+8+16], xmm0
			dec ecx
			lea edi, [edi+32]
		.Until Zero?
	cyct_end <lddqu+movlps B>
	ENDM
	if ShowAll
		cyct_begin
		mov esi, offset src
		mov edi, offset dest
		mov ecx, ByteCount/16
		.Repeat
			movlps xmm0, qword ptr [esi]			; fast for Celeron, especially srcalign 8
			movlps qword ptr [edi], xmm0
			lea esi, [esi+32]
			movhps xmm0, qword ptr [esi-8-16]
			movhps qword ptr [edi+8], xmm0
			dec ecx
			.Break .If Zero?
			lea edi, [edi+32]
			movlps xmm0, qword ptr [esi-16]		; fast for Celeron, especially srcalign 8
			movlps qword ptr [edi-16], xmm0
			movhps xmm0, qword ptr [esi-16-8]
			movhps qword ptr [edi-16+8], xmm0
			dec ecx
		.Until Zero?
	cyct_end <** movlps/movhps>

	cyct_begin
		mov esi, offset src
		mov edi, offset dest
		mov ecx, ByteCount/16
		.Repeat
			movlps xmm0, qword ptr [esi]
			movhps xmm0, qword ptr [esi+8]
			lea esi, [esi+16]
			movdqu [edi], xmm1
			lea edi, [edi+16]
			dec ecx
		.Until Zero?
	cyct_end <movlps+movdqu>

	cyct_begin
		mov esi, offset src
		mov edi, offset dest
		mov ecx, ByteCount/16*4
		rep movsd
	cyct_end <rep movsd      >

	cyct_begin
		mov esi, offset src
		mov edi, offset dest
		mov ecx, ByteCount/16
		.Repeat
			movdqu xmm1, [esi]
			lea esi, [esi+16]
			movdqu [edi], xmm1
			lea edi, [edi+16]
			dec ecx
		.Until Zero?
	cyct_end <movdqu          >

	cyct_begin
		mov esi, offset src
		mov edi, offset dest
		ffree st(7)
		mov ecx, ByteCount/16*2
		.Repeat
			fild qword ptr [esi]
			lea esi, [esi+8]
			fistp qword ptr [edi]
			lea edi, [edi+8]
			dec ecx
		.Until Zero?
	cyct_end <fild/fistp     >
	endif

	inkey chr$(13, 10, 10, "--- ok ---", 13)
	exit

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 16
MemCo0 proc pDest, pSrc, ct			; preserve ecx, return dest start in eax, dest end in edx
  push esi
  push edi
  push ecx
  mov edi, [esp+12+4]			; dest - see [url=TestJJ\MemCopyJJ.asc]MemCoLMemCoMemCoJ[/url] for more speed
  mov esi, [esp+12+8]			; src
  mov ecx, [esp+12+12]		; ct
  test esi, 15					; src-aligned
  je @F
  cmp ecx, 16
  jle @F
  if UsePP
	push ecx
	mov ecx, esi
	neg ecx
	and ecx, 15
	sub [esp], ecx
	rep movsb
	pop ecx				; reload ct
  else
	mov ecx, esi
	neg ecx
	and ecx, 15
	sub [esp+12+12], ecx
	rep movsb
	mov ecx, [esp+12+12]	; reload ct
  endif
@@:
  push ecx
  shr ecx, 2
  rep movsd
  pop ecx
  and ecx, 3
  rep movsb
  pop ecx
  pop edi
  pop esi
  ret 12
MemCo0 endp
MemCo0_END:

align 16
MemCo1 proc pDest, pSrc, ct	; preserve ecx, return dest start in eax, dest end in edx
  push esi
  push edi
  push ecx
  mov edi, [esp+12+4]			; dest - see [url=TestJJ\MemCopyJJ.asc]MemCoLMemCoMemCoJ[/url] for more speed
  mov esi, [esp+12+8]			; src
  mov ecx, [esp+12+12]		; ct
  test edi, 15					; dest-aligned
  je @F
  cmp ecx, 16
  jle @F
  if UsePP
    if 0	; slightly slower, one byte more (P4)
	; push ecx
	mov eax, ecx
	mov ecx, edi
	neg ecx
	and ecx, 15
	; sub [esp], ecx		; correct the counter for the bytes we deal with here
	sub eax, ecx
	push ecx
	shr ecx, 2
	rep movsd
	pop ecx
	and ecx, 3
	rep movsb
	; pop ecx				; reload ct
	mov ecx, eax
    else
	push ecx
	mov ecx, edi
	neg ecx
	and ecx, 15
	sub [esp], ecx		; correct the counter for the bytes we deal with here
	push ecx
	shr ecx, 2
	rep movsd
	pop ecx
	and ecx, 3
	rep movsb
	pop ecx				; reload ct
    endif
@@:
  push ecx
  shr ecx, 2
  else
	mov ecx, edi
	neg ecx
	and ecx, 15
	sub [esp+12+12], ecx
	rep movsb
	mov ecx, [esp+12+12]	; reload ct
@@:
  push ecx
  shr ecx, 2
  endif
  rep movsd
  pop ecx
  and ecx, 3
  rep movsb
  pop ecx
  pop edi
  pop esi
  ret 12
MemCo1 endp
MemCo1_END:

align 16
MemCo2 proc pDest, pSrc, ct	; preserve ecx, return dest start in eax, dest end in edx
  push esi
  push edi
  push ecx
  mov edi, [esp+12+4]		; dest
  mov esi, [esp+12+8]		; src
  mov ecx, [esp+12+12]	; ct
;  .if DestShowVar==0
;	mov DestShowVar, esi
;	call DestShow
;	MsgBox 0, str$(len(esi)), "Hi", MB_OK
;  .endif
  ChkResult = 0
  lineifat ChkResult, call DestClear		; to test correctness of result
  shr ecx, 5				; /32
  je DoTheTail
  mov eax, esi
  sub eax, edi
  test eax, 15
  jne MisAlign				; src-dest difference not divisible by 16
  test esi, 15
  je @F
  mov ecx, esi
  neg ecx
  and ecx, 15
  sub [esp+12+12], ecx	; we will deal with 15 bytes max
  push ecx
  shr ecx, 2	; /4 for movsd
  rep movsd
  pop ecx
  and ecx, 3	; tail as movsb
  rep movsb
  mov ecx, [esp+12+12]	; reload ct
  shr ecx, 5				; /32
  je DoTheTail

@@:
  .Repeat
	movdqa xmm0, [esi]			; further unrolling slows down the algo
	movdqa [edi], xmm0			; write dest
	movdqa xmm0, [esi+16]			; further unrolling slows down the algo
	movdqa [edi+16], xmm0			; write dest
	lea esi, [esi+32]
	dec ecx									; 4 cycles less if in the middle (?)
	lea edi, [edi+32]
  .Until Zero?
  Jmp DoTheTail

MisAlign:		; Co2
	.Repeat
		test edi, 15
		.Break .If Zero?			; align edi to para
		movsb
	.Until 0
	and eax, 15
	and esi, -16					; align esi to para
	mov edx, eax
	shl edx, 3
	.if eax>8
		sub edx, 8*8			; use first loop
	.endif
	movd xmm4, edx			; shift count
	sub edx, 64
	neg edx
	movd xmm3, edx
	mov ecx, [esp+12+12]		; reload ct
	shr ecx, 4
	.if eax>8					; >8 = align dest>align src
		.Repeat
			movq xmm2, qword ptr [esi+8]	; or use movlps - but movq is a lot faster on P4
			movhps xmm2, qword ptr [esi+16]	; note movq trashes hiQword, must come before movhps
			lddqu xmm1, oword ptr [esi+16]
			psrlq xmm2, xmm4
			psllq xmm1, xmm3
			por xmm1, xmm2
			movdqa [edi], xmm1
			lea esi, [esi+16]
			dec ecx
			lea edi, [edi+16]
		.Until Zero?
	.else
		.Repeat
			movq xmm2, qword ptr [esi+8]	; or use movlps - but  movq is a lot faster on P4
			movhps xmm2, qword ptr [esi+16]
			lddqu xmm1, oword ptr [esi]
			psrlq xmm1, xmm4
			psllq xmm2, xmm3
			por xmm1, xmm2
			movdqa [edi], xmm1
			lea esi, [esi+16]
			dec ecx
			lea edi, [edi+16]
		.Until Zero?
	.endif
	lea edi, [edi-16]
	lea esi, [esi-16]
;	.Repeat
;		mov al, [edi]
;		or al, 127
;		stosb
;		dec ecx
;	.Until Zero?
;	mov dword ptr [edi], "XXXX"

DoTheTail:
  mov ecx, [esp+12+12]	; get original counter
  and ecx, 31	; higher bits dealt with by SSE2 part
  if UseRepMov	; slow
	shr ecx, 2
	rep movsd
  else
	shr ecx, 2
	je @F
	.Repeat
		mov eax, [esi]	; movsb, lodsd, stosd a lot slower on P4
		mov [edi], eax
		add esi, 4
		add edi, 4
		dec ecx
	.Until Zero?
  endif
@@:
  mov ecx, [esp+12+12]	; get original counter
  and ecx, 3
  rep movsb
  lineifat ChkResult, call DestShow		; to test correctness of result
  pop ecx
  pop edi
  pop esi
  ret 12
MemCo2 endp
MemCo2_END:

align 16
MemCoC3 proc pDest, pSrc, ct	; Celeron's darling (preserve ecx, return dest start in eax, dest end in edx)
  push esi
  push edi
  push ecx
  mov edi, [esp+12+4]		; dest
  mov esi, [esp+12+8]		; src
  mov ecx, [esp+12+12]	; ct
  ChkResult = 0
  lineifat ChkResult, call DestClear		; to test correctness of result
  shr ecx, 5				; /32
  je DoTheTail
  mov eax, esi
  sub eax, edi
  and eax, 15
  jne MisAlign				; src-dest difference not divisible by 16
  test esi, 15
  je @F
  mov ecx, esi
  neg ecx
  and ecx, 15
  sub [esp+12+12], ecx	; we will deal with 15 bytes max
  push ecx
  shr ecx, 2	; /4 for movsd
  rep movsd
  pop ecx
  and ecx, 3	; tail as movsb
  rep movsb
  mov ecx, [esp+12+12]	; reload ct
  shr ecx, 5				; /32
  je DoTheTail

@@:
  .Repeat
	movdqa xmm0, [esi]			; further unrolling slows down the algo
	movdqa [edi], xmm0			; write dest
	movdqa xmm0, [esi+16]			; further unrolling slows down the algo
	movdqa [edi+16], xmm0			; write dest
	lea esi, [esi+32]
	dec ecx									; 4 cycles less if in the middle (?)
	lea edi, [edi+32]
  .Until Zero?
  Jmp DoTheTail

MisAlign:	; Co3
  mov ecx, [esp+12+12]	; reload ct
  shr ecx, 4				; /16
  if 0
  .if debflag
  	mov edx, eax
  	and edx, 63
  	and eax, 15
  	deb 1, "Align", eax, ecx, edx
  	and debflag, 0
  .endif
  endif
;  .if DestShowVar==0
;	int 3
;  .endif
  if 0
  cmp eax, 8
  jmp Usedqa						; FAST BUT MAKES NO SENSE
  test esi, 15						; source is aligned, dest not
  je @F
  movdqu xmm0, [esi]				; read src
  movlps qword ptr [edi], xmm0	; write dest
  movhps qword ptr [edi+8], xmm0
  mov eax, esi
  and esi, -16						; xxxxxxxxx1234567abcdefghijklmnop
  lea esi, [esi+16]					; xxxxxxxxx1234567abcdefghijklmnop
  sub eax, esi
  sub edi, eax
@@:
  .Repeat
	if 1
	movdqa xmm0, [esi]					; further unrolling slows down the algo
	movdqu [edi], xmm0			; write dest
	movdqa xmm1, [esi+16]
	movdqu [edi+16], xmm1			; write dest
	else
	movdqa xmm0, [esi]					; further unrolling slows down the algo
	movlps qword ptr [edi], xmm0			; write dest
	movhps qword ptr [edi+8], xmm0
	movdqa xmm1, [esi+16]
	movdqu [edi], xmm1			; write dest
	endif
	lea esi, [esi+32]
	dec ecx										; 4 cycles less if in the middle (?)
	lea edi, [edi+32]
  .Until Zero?
  jmp DoTheTail
  endif

Usedqa:
  test edi, 15						; dest is aligned, src not
  je @F
  movdqu xmm0, [esi]				; read src
  movlps qword ptr [edi], xmm0	; write dest
  movhps qword ptr [edi+8], xmm0
  mov eax, edi
  and edi, -16						; xxxxxxxxx1234567abcdefghijklmnop
  lea edi, [edi+16]					; xxxxxxxxx1234567abcdefghijklmnop
  sub eax, edi
  sub esi, eax
@@:
  .Repeat
	if 0
		lddqu xmm0, oword ptr [esi]			; fast for Celeron, especially srcalign 8??? destalign 8 seems faster
		lea esi, [esi+32]
		movlps qword ptr [edi], xmm0
		; movhps xmm0, qword ptr [esi-8]
		movhps qword ptr [edi+8], xmm0
	elseif 0			; movq 22 cycles slower on Celeron
		movq xmm0, qword ptr [esi]			; fast for Celeron, especially srcalign 8??? destalign 8 seems faster
		movlps qword ptr [edi], xmm0
		lea esi, [esi+32]
		movq xmm0, qword ptr [esi-8-16]
		movhps qword ptr [edi+8], xmm0
	else
		movlps xmm0, qword ptr [esi]			; fast for Celeron, especially srcalign 8??? destalign 8 seems faster
		movlps qword ptr [edi], xmm0
		lea esi, [esi+32]
		movhps xmm0, qword ptr [esi-8-16]
		movhps qword ptr [edi+8], xmm0
	endif
		dec ecx
		.Break .If Zero?
		lea edi, [edi+32]
		movlps xmm0, qword ptr [esi-16]
		movlps qword ptr [edi-16], xmm0
		movhps xmm0, qword ptr [esi-16-8]
		movhps qword ptr [edi-16+8], xmm0
		dec ecx
  .Until Zero?

DoTheTail:
  mov ecx, [esp+12+12]	; get original counter
  and ecx, 31	; higher bits dealt with by SSE2 part
  if UseRepMov	; slow
	shr ecx, 2
	rep movsd
  else
	shr ecx, 2
	je @F
	.Repeat
		mov eax, [esi]	; movsb, lodsd, stosd a lot slower on P4
		mov [edi], eax
		add esi, 4
		add edi, 4
		dec ecx
	.Until Zero?
  endif
@@:
  mov ecx, [esp+12+12]	; get original counter
  and ecx, 3
  rep movsb
  lineifat ChkResult, call DestShow		; to test correctness of result
  pop ecx
  pop edi
  pop esi
  ret 12
MemCoC3 endp
MemCoC3_END:

MemCo6 proc pDest, pSrc, ct	; preserve ecx, return dest start in eax, dest end in edx
  push esi
  push edi
  push ecx
  mov edi, [esp+12+4]			; dest - see [url=TestJJ\MemCopyJJ.asc]MemCoLMemCoLJ[/url] for more speed
  mov esi, [esp+12+8]			; src
  mov ecx, [esp+12+12]		; ct
  shr ecx, 4
  je @F
		.Repeat
			movlps xmm0, qword ptr [esi]			; fast for Celeron, especially srcalign 8??? destalign 8 seems faster
			movlps qword ptr [edi], xmm0
			lea esi, [esi+32]
			movhps xmm0, qword ptr [esi-8-16]
			movhps qword ptr [edi+8], xmm0
			dec ecx
			.Break .If Zero?
			lea edi, [edi+32]
			movlps xmm0, qword ptr [esi-16]
			movlps qword ptr [edi-16], xmm0
			movhps xmm0, qword ptr [esi-16-8]
			movhps qword ptr [edi-16+8], xmm0
			dec ecx
		.Until Zero?
@@:
  mov ecx, [esp+12+12]		; ct
  and ecx, 31
  rep movsb
;  call DestShow
  pop ecx
  pop edi
  pop esi
  ret 12
MemCo6 endp
MemCo6_END:

COMMENT @
[url=http://www.rz.uni-karlsruhe.de/rz/docs/VTune/reference/vc259.htm]PSLLW/PSLLD/PSLLQ--Packed Shift Right Logical[/url]
PSRLQ xmm1, xmm2/m128
Shift quadwords in xmm1 right by amount specified in xmm2/m128 while shifting in 0s

[url=http://www.ews.uiuc.edu/~cjiang/reference/vc256.htm]PSLLW/PSLLD/PSLLQ--Packed Shift Left Logical[/url]
PSLLQ xmm1, xmm2/m128
Shift quadwords in xmm1 left by amount specified in xmm2/m128, while shifting in 0s
@
align 16
MemCoP4 proc pDest, pSrc, ct	; preserve ecx, return dest start in eax, dest end in edx
  push esi
  push edi
  push ecx
  mov edi, [esp+12+4]		; dest
  mov esi, [esp+12+8]		; src
  mov ecx, [esp+12+12]	; ct
  ChkResult = 0
  lineifat ChkResult, call DestClear		; to test correctness of result
  shr ecx, 5				; /32
  je DoTheTail
  mov eax, esi
  sub eax, edi
  and eax, 15
  jne MisAlign				; src-dest difference not divisible by 16
  test esi, 15
  je @F
  mov ecx, esi
  neg ecx
  and ecx, 15
  sub [esp+12+12], ecx	; we will deal with 15 bytes max
  push ecx
  shr ecx, 2	; /4 for movsd
  rep movsd
  pop ecx
  and ecx, 3	; tail as movsb
  rep movsb
  mov ecx, [esp+12+12]	; reload ct
  shr ecx, 5				; /32
  je DoTheTail

@@:
  .Repeat
	movdqa xmm0, [esi]			; further unrolling slows down the algo
	movdqa [edi], xmm0			; write dest
	movdqa xmm0, [esi+16]			; further unrolling slows down the algo
	movdqa [edi+16], xmm0			; write dest
	dec ecx									; 4 cycles less if in the middle (?)
	lea esi, [esi+32]
	lea edi, [edi+32]
  .Until Zero?
  Jmp DoTheTail

MisAlign:	; CoP4
  test edi, 15						; dest is aligned, src not
  je @F
  lddqu xmm0, oword ptr [esi]		; read src
	if 0
  movq qword ptr [edi], xmm0		; write dest
  movq qword ptr [edi+8], xmm0	; movq: 2 bytes more, not a single cycle faster
	else
  movlps qword ptr [edi], xmm0	; write dest
  movhps qword ptr [edi+8], xmm0
	endif
  mov eax, edi
  and edi, -16						; xxxxxxxxx1234567abcdefghijklmnop
  lea edi, [edi+16]					; xxxxxxxxx1234567abcdefghijklmnop
  sub eax, edi
  sub esi, eax
@@:
  .Repeat
	lddqu xmm0, oword ptr [esi]				; further unrolling slows down the algo
	movdqa [edi], xmm0						; write dest
	lddqu xmm0, oword ptr [esi+16]			; on P4, lddqu is 30% faster than movdqu
	movdqa [edi+16], xmm0					; write dest
	dec ecx										; 4 cycles less if in the middle (?)
	lea esi, [esi+32]
	lea edi, [edi+32]
  .Until Zero?

DoTheTail:
  mov ecx, [esp+12+12]	; get original counter
  and ecx, 31	; higher bits dealt with by SSE2 part
  shr ecx, 2
  if UseRepMov	; slow
	rep movsd
  else
	je @F
	.Repeat
		mov eax, [esi]		; movsb, lodsd, stosd a lot slower on P4
		mov [edi], eax
		if 0
			lea esi, [esi+4]		; lea and exactly the same on P4
			lea edi, [edi+4]
		else
			add esi, 4
			add edi, 4
		endif
		dec ecx
	.Until Zero?
  endif
@@:
  mov ecx, [esp+12+12]	; get original counter
  and ecx, 3
  rep movsb
  lineifat ChkResult, call DestShow		; to test correctness of result
  pop ecx
  pop edi
  pop esi
  ret 12
MemCoP4 endp
MemCoP4_END:

MemCoC2 proc pDest, pSrc, ct	; preserve ecx, return dest start in eax, dest end in edx
  push esi
  push edi
  push ecx
  mov edi, [esp+12+4]		; dest
  mov esi, [esp+12+8]		; src
  mov ecx, [esp+12+12]	; ct
  ChkResult = 0
  lineifat ChkResult, call DestClear		; to test correctness of result
  shr ecx, 5				; /32
  je DoTheTail
  mov eax, esi
  sub eax, edi
  and eax, 15
;  .if sdword ptr DestShowVar>0
;	int 3
;  .endif
  jne MisAlign				; src-dest difference not divisible by 16
  test esi, 15
  je @F
  mov ecx, esi
  neg ecx
  and ecx, 15
  sub [esp+12+12], ecx	; we will deal with 15 bytes max
  push ecx
  shr ecx, 2	; /4 for movsd
  rep movsd
  pop ecx
  and ecx, 3	; tail as movsb
  rep movsb
  mov ecx, [esp+12+12]	; reload ct
  shr ecx, 5				; /32
  je DoTheTail

@@:
  .Repeat
	movdqa xmm0, [esi]			; further unrolling slows down the algo
	movdqa [edi], xmm0			; write dest
	movdqa xmm0, [esi+16]			; further unrolling slows down the algo
	movdqa [edi+16], xmm0			; write dest
	lea esi, [esi+32]
	dec ecx									; 4 cycles less if in the middle (?)
	lea edi, [edi+32]
  .Until Zero?
  Jmp DoTheTail

MisAlign:	; CoC2
;  .if debflag
;  	mov edx, eax
;  	and edx, 63
;  	and eax, 15
;  	deb 1, "Align", eax, edx
;  	and debflag, 0
;  .endif
  cmp eax, 8
  ja UseMov						; ja is the +n case
  test edi, 15						; dest is aligned, src not (moved here from MemCoP4)
  je @F
  lddqu xmm0, oword ptr [esi]		; read src
  movlps qword ptr [edi], xmm0	; write dest
  movhps qword ptr [edi+8], xmm0
  mov eax, edi
  and edi, -16						; xxxxxxxxx1234567abcdefghijklmnop
  lea edi, [edi+16]					; xxxxxxxxx1234567abcdefghijklmnop
  sub eax, edi
  sub esi, eax
@@:
  .Repeat
	lddqu xmm0, oword ptr [esi]				; further unrolling slows down the algo
	movdqa [edi], xmm0						; write dest
	lddqu xmm0, oword ptr [esi+16]			; on P4, lddqu is 30% faster than movdqu
	movdqa [edi+16], xmm0					; write dest
	dec ecx										; 4 cycles less if in the middle (?)
	lea esi, [esi+32]
	lea edi, [edi+32]
  .Until Zero?
  jmp DoTheTail

UseMov:
  test edi, 15						; dest is aligned, src not
  je @F
  movdqu xmm0, [esi]				; read src
  movlps qword ptr [edi], xmm0	; write dest
  movhps qword ptr [edi+8], xmm0
  mov eax, edi
  and edi, -16						; xxxxxxxxx1234567abcdefghijklmnop
  lea edi, [edi+16]					; xxxxxxxxx1234567abcdefghijklmnop
  sub eax, edi
  sub esi, eax
@@:
  .Repeat
	if 1
	movdqu xmm0, [esi]					; further unrolling slows down the algo
	movdqa [edi], xmm0			; write dest
	movdqu xmm1, [esi+16]
	movdqa [edi+16], xmm1			; write dest
	else
	movlps xmm0, qword ptr [esi]
	movhps xmm0, qword ptr [esi+8]
	movdqa [edi], xmm0					; further unrolling slows down the algo
	movlps xmm0, qword ptr [esi+16]
	movhps xmm0, qword ptr [esi+16+8]
	movdqa [edi+16], xmm0
	endif
	lea esi, [esi+32]
	dec ecx										; 4 cycles less if in the middle (?)
	lea edi, [edi+32]
  .Until Zero?

DoTheTail:
  mov ecx, [esp+12+12]	; get original counter
  and ecx, 31	; higher bits dealt with by SSE2 part
  if UseRepMov	; slow
	shr ecx, 2
	rep movsd
  else
	shr ecx, 2
	je @F
	.Repeat
		mov eax, [esi]	; movsb, lodsd, stosd a lot slower on P4
		mov [edi], eax
		add esi, 4
		add edi, 4
		dec ecx
	.Until Zero?
  endif
@@:
  mov ecx, [esp+12+12]	; get original counter
  and ecx, 3
  rep movsb
  lineifat ChkResult, call DestShow
  pop ecx
  pop edi
  pop esi
  ret 12
MemCoC2 endp
MemCoC2_END:

DestClear proc
.data?
	DestShowVar	dd ?
.code
  pushad
  .if DestShowVar==0
	mov DestShowVar, edi
	xor eax, eax
	rep stosb
  .endif
  popad
  ret
DestClear endp

DestShow proc
  pushad
  .if sdword ptr DestShowVar>0
  	mov edi, DestShowVar
	or DestShowVar, -1
	print chr$(13, 10, "Dest:",13,10)
	mov eax, cyctStrLen
	sub eax, 16
	mov dword ptr [edi+eax-96], "69-:"		; show the end of the text as tx_OK
	mov dword ptr [edi+eax-80], "08-:"		; show the end of the text as tx_OK
	mov dword ptr [edi+eax-64], "46-:"		; show the end of the text as tx_OK
	mov dword ptr [edi+eax-48], "84-:"		; show the end of the text as tx_OK
	mov dword ptr [edi+eax-32], "23-:"		; show the end of the text as tx_OK
	mov dword ptr [edi+eax-16], "61-:"		; show the end of the text as tx_OK
;	mov dword ptr [edi+eax-4], "KO_x"		; show the end of the text as tx_OK
	print edi
	print chr$("*",13,10)
  .endif
  popad
  ret
DestShow endp

ShowCpu proc mode:DWORD
COMMENT	@ Usage: 
Move this line up:
ShowCpu	PROTO:DWORD

	invoke ShowCpu, 0		; simple, no printing, just returns SSE level
	invoke ShowCpu, 1		; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp
ShowCpue:

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 
align 4
MemCoL proc public uses esi edi Source:PTR BYTE,Dest:PTR BYTE,ln:DWORD
    ; This procedure was written by Tim Roberts
    ; ---------------------------------------------------------
    ; Copy ln bytes of memory from Source buffer to Dest buffer
    ;      ~~                      ~~~~~~           ~~~~
    ; USAGE:
    ; invoke MemCoL,ADDR Source,ADDR Dest,4096
    ; invoke MemCoL,ADDR Dest,ADDR Source,4096	; jj2007
    ;
    ; NOTE: Dest buffer must be at least as large as the source
    ;       buffer otherwise a page fault will be generated.
    ; ---------------------------------------------------------

;    cld			; changed by jj2007
    mov edi, [Source]		; changed by jj2007
    mov esi, [Dest]
    mov ecx, [ln]
    shr ecx, 2
    rep movsd

    mov ecx, [ln]
    and ecx, 3
    rep movsb
    ret

MemCoL endp
MemCoL_END:

printFixP proc	; invoke printFixP, ecx:strlen, eax:reparg(arg)
  push esi
  push edi
  push ebx
  mov ebx, ecx					; slot width
  mov esi, eax						; src
  mov edi, offset cyctFixPbuf		; dest
  mov ecx, len(eax)				; ex slot = 10, str = 6
  mov al, 32
  stosb							; leading space
  .if sdword ptr ebx<0				; right aligned:  ____MyText
	neg ebx						; 10
	sub ecx, ebx				; 6-10=-4
	.if sdword ptr ecx<0		; normal case
		.Repeat
			inc ecx
			.Break .if !Sign?
			stosb				; write spaces
		.Until 0
	.endif
	dec ebx
	.Repeat
		dec ebx
		.Break .if Sign?
		movsb				; write string
	.Until 0
  .else
  	.if byte ptr [esi]==13
	  	add ebx, 2
	.endif
	sub ecx, ebx				; 6-10=-4
	.Repeat
		dec ebx
		.Break .if Sign?
		lodsb
		.Break .if al==0
		stosb
	.Until 0
	dec ecx
	.if Sign?					; text shorter than slot
		mov al, 32				; add spaces
		.Repeat
			inc ecx
			.Break .if Zero?
			stosb
		.Until 0
	.endif
  .endif
  mov byte ptr [edi], 0	; delimiter
  print offset cyctFixPbuf
  pop ebx
  pop edi
  pop esi
  ret
printFixP endp

cyct_endP proc
  push ebp
  push esi
  push ebx
  push eax
  inc edx
  invoke CombSortA, offset cyctSortTable, edx
  xor ebx, ebx
  ifline cyctTableMode!<=0, print chr$(13, 10)
  if cyctShowSlow
	print chr$(10)
	.Repeat
  		print str$(ebx), ":"
		mov eax, [cyctSortTable+4*ebx]
		print str$(eax), " "
	  	inc ebx
	.Until ebx>cyctCutFast
	if cyctShowSlow gt 0
		print chr$(13, 10, 10, "...", 13, 10, 10)
		mov ebx, cyctCounter
		sub ebx, cyctShowSlow
		.Repeat
  			print str$(ebx), ":"
			mov eax, [cyctSortTable+4*ebx]
			print str$(eax), " "
  			inc ebx
		.Until ebx>=cyctCounter
	endif
  endif
  pop ebp	; pushed as eax
  if cyctShowDiff
  .if byte ptr [ebp]!="#"
	print chr$(13, 10)
	print ebp
	print chr$(13, 10, "average with cutoff", 9)
  .endif
  endif
  push cyctCutFast
  pop ebx
  mov eax, [cyctSortTable+4*cyctCutFast]		;; determine the cutoff value
  mov esi, eax			; eax is one of the lowest timings
  shr esi, 2			; /4
  inc esi
  add esi, eax			; esi = eax * 1.25 + 1
  xor eax, eax
  .Repeat
	mov ecx, [cyctSortTable+4*ebx]
	inc ebx
	.Break .if ecx>esi
	add eax, ecx
  .Until ebx>cyctCounter
  sub ebx, cyctCutFast+2
  je @F
  cdq
  div ebx
  @@:
  push eax
  .if cyctTableMode
	printFix cyctColW, str$(eax)		; the actual cycles
  .else
	print str$(eax)
  .endif
  .if byte ptr [ebp]!="#"
	if cyctShowDiff
		.if ebx<=sizeof cyctSortTable/4-cyctCutFast-1
			print chr$(32, 9, "cutoff at n=")
			add ebx, cyctCutFast+1
			print str$(ebx), " for ", 62		; >n cycles
			print str$(esi), " cycles"
		.else
  			print chr$(32, 9, "no cutoff")
		.endif
		print chr$(13, 10, "average w/o cutoff ", 9)
	else
		.if cyctTableMode==0
			.if ebx<=sizeof cyctSortTable/4-cyctCutFast-1
				add ebx, cyctCutFast+1
				.if ebx<400
					print "*"
				.endif
			.endif
			print chr$(9)
			print ebp
		.endif
	endif
  .endif
  xor eax, eax
  xor ebx, ebx
  mov edx, cyctCounter
  .Repeat
	add eax, [cyctSortTable+4*ebx]
	inc ebx
  .Until ebx>edx
  test eax, eax
  js @F	; something is wrong here
  dec ebx
  je @F	; rare event
  cdq
  div ebx
  @@:
  mov ebx, eax
  .if byte ptr [ebp]!="#"
	if cyctShowDiff
		print str$(eax), 13, 10, "difference raw-cutoff:", 9
		sub ebx, [esp]
		print str$(ebx)
	endif
  .endif
  if cyctShowSize
	print "    ", 9, "codesize="
	print str$(cyctSize), " bytes"
  endif
  pop eax
  pop ebx
  pop esi
  pop ebp
  ret
cyct_endP endp

ChkMe proc
	mov edx, offset src16
	mov eax, offset dest16
	xor ecx, ecx
	.Repeat
		mov [eax], ecx
		mov [eax+4], ecx
		mov [eax+8], ecx
		mov [eax+12], ecx
		movlps xmm0, qword ptr [eax]
		movhps xmm0, qword ptr [eax+8]
		movlps qword ptr [edx], xmm0	; write dest
		movhps qword ptr [edx+8], xmm0
		.if [edx]!=ecx || [edx+4]!=ecx || [edx+8]!=ecx || [edx+12]!=ecx
			MsgBox 0, str$(ecx), "Bad luck...", MB_OK
			.Break
		.endif
		inc ecx
	.Until Zero?
	ret
ChkMe endp
end start

RichMasm options:
OxPT_Linker	link	; If present in \bin, PoLink.exe will be used; delete the x to force link.exe
OPT_Assembler	ml	; If present in \bin, JWasm.exe will be used; delete the x to force link.exe
OPT_DebugL	/MERGE:.data=.rdata /MERGE:.rdata=.text	; for ultra short executables
OPT_NoWarn	LNK4254, multiple	; we ignore linker warnings found in this string, e.g. section a merged into b with different attributes
OPT_WAIT	0		; wait until a key is pressed before closing the DOS box
OPT_Tmp2Asm	1

[url=http://msdn.microsoft.com/en-us/library/aa366574.aspx]GlobalAlloc[/url]:
Memory allocated with this function is guaranteed to be aligned on an 8-byte boundary

[url=http://msdn.microsoft.com/en-us/library/ms713418(VS.85).aspx]timeGetTime[/url]
Returns the system time, in milliseconds.
timeBeginPeriod(milliseconds)
timeEndPeriod(milliseconds)
You must match each call to timeBeginPeriod with a call to timeEndPeriod, specifying the same minimum resolution in both calls. An application can make multiple timeBeginPeriod calls as long as each call is matched with a call to timeEndPeriod.

Timings:
Intel(R) Pentium(R) 4 CPU 3.40GHz (SSE3)
Algo         _imp__st   MemCo1   MemCo2  MemCoC3  MemCoP4  MemCoC2   MemCoL
Description       CRT rep movs   movdqa  lps+hps   movdqa   movdqa   Masm32
               strcpy  dest-al    psllq src+dest  dest-al   src-al  library
Code size           ?       70      291      222      200      269       33
---------------------------------------------------------------------------
2048, d0s0-0     2379      742      609      614      614      615      749
2048, d1s1-0     2400      829      635      638      645      640     4409
2048, d7s7-0     2410      834      647      647      646      643     4408
2048, d7s8-1     5460     1435     1223     1869      606     4015     4365
2048, d7s9-2     4958     1439     1226     1867      610     4008     4442
2048, d8s7+1     4956     1430     1191     1295      612     1017     1329
2048, d8s8-0     2370      838      655      654      650      647      996
2048, d8s9-1     4945     1441     1206     1866      612     4087     1350
2048, d9s7+2     4940     1431     1176     1287      609     1017     4466
2048, d9s8+1     4930     1433     1177     1292      613     1017     4352
2048, d9s9-0     2375      835      657      658      651      650     4393
2048, d15s15     2364      839      651      649      656      653     4404

Intel(R) Celeron(R) M CPU        420  @ 1.60GHz (SSE3)
Algo         _imp__st   MemCo1   MemCo2  MemCoC3  MemCoP4  MemCoC2   MemCoL
Description       CRT rep movs   movdqa  lps+hps   movdqa   movdqa   Masm32
               strcpy  dest-al    psllq src+dest  dest-al   src-al  library
Code size           ?       70      291      222      200      269       33
---------------------------------------------------------------------------
2048, d0s0-0     2591      566      363      363      373      363      560
2048, d1s1-0     2603      619      421      423      444      423     1690
2048, d7s7-0     2585      619      419      421      446      421     1684
2048, d7s8-1     2581     1704     1090     1476      909      834     1253
2048, d7s9-2     2600     1704     1090     1477      909      834     1737
2048, d8s7+1     2585     1717     1090      887      950      915     1662
2048, d8s8-0     2582      619      421      423      448      423      560
2048, d8s9-1     2605     1704     1083     1476      909      834     1679
2048, d9s7+2     2585     1718     1081      887      950      915     1767
2048, d9s8+1     2582     1718     1081      887      950      915     1253
2048, d9s9-0     2589      619      421      423      448      423     1765
2048, d15s15     2575      619      423      425      446      424     1723

Intel(R) Celeron(R) M CPU        420  @ 1.60GHz (SSE3)
Algo         _imp__st   MemCo1   MemCo2  MemCoC3  MemCoP4  MemCoC2   MemCoL
Description       CRT rep movs   movdqa  lps+hps   movdqa   movdqa   Masm32
               strcpy  dest-al    psllq src+dest  dest-al   src-al  library
Code size           ?       70      291      222      200      269       33
---------------------------------------------------------------------------
2048, d0s0-0     2591      566      363      363      373      363      560
2048, d1s1-0     2598      619      421      423      444      423     1726
2048, d7s7-0     2584      619      419      421      446      421     1735
2048, d7s8-1     2782     1525     1090      441      956     1033     1527
2048, d7s9-2     2788     1526     1090      441      957     1033     1755
2048, d8s7+1     2786     1309     1090      683      809      815     1467
2048, d8s8-0     2581      619      421      423      448      423      560
2048, d8s9-1     2789     1526     1083      441      956     1033     1465
2048, d9s7+2     2790     1309     1081      684      809      815     1802
2048, d9s8+1     2782     1309     1081      684      809      815     1511
2048, d9s9-0     2589      619      421      423      448      423     1737
2048, d15s15     2582      619      423      425      446      424     1723

Intel(R) Core(TM) i7 CPU         920  @ 2.67GHz (SSE4, [url=http://www.masm32.com/board/index.php?topic=11454.msg87601#msg87601]Ramguru[/url])
Algo         _imp__st   MemCo1   MemCo2  MemCoC3  MemCoP4  MemCoC2   MemCoL
Description       CRT rep movs   movdqa  lps+hps   movdqa   movdqa   Masm32
               strcpy  dest-al    psllq src+dest  dest-al   src-al  library
Code size           ?       70      291      222      200      269       33
---------------------------------------------------------------------------
2048, d0s0-0     1985      191      204      205      203      175      196
2048, d1s1-0     1992      223      251      248      251      222      244
2048, d7s7-0     1982      227      253      250      248      223      243
2048, d7s8-1     1976      246      592      501      193      211      243
2048, d7s9-2     1986      247      594      501      194      212      243
2048, d8s7+1     1982      249      587      501      193      179      244
2048, d8s8-0     1976      229      255      253      251      226      243
2048, d8s9-1     1983      249      588      502      194      211      243
2048, d9s7+2     1982      248      583      501      193      179      243
2048, d9s8+1     1977      249      583      501      193      179      243
2048, d9s9-0     1984      229      255      253      251      226      244
2048, d15s15     1974      228      256      256      258      226      243

